#ifndef MINOBLOCKS_H
#define MINOBLOCKS_H

#include "TetrisCommon.h"
#include "Point2D.h"

// Minǒ`ABaseƂȂ΍WƁȂ΍WňʒueBlockŕ\
class CMinoBlocks
{
protected:
	struct SMinoOneBlock
	{
		CPoint2D<int> point;             // Block̑΍W
		ETetrisBlockState blockState;

		SMinoOneBlock() : point(0,0), blockState(BLOCKSTATE_NONE) {}
	};

public:
	CMinoBlocks(unsigned int blockNum);
	explicit CMinoBlocks(const CMinoBlocks& obj);
	virtual ~CMinoBlocks();

	// ʂMinoBlocksɃRs[ BlockNum̏ꍇ̂ݐ
	bool Copy(const CMinoBlocks& rSrc);

	// BaseWԂ
	CPoint2D<int>& GetBaseCoordinate() { return m_ptBase; }
	// BaseWړ BaseWړ邾ŁAMinǒ`͂̂܂܂ƂȂ
	void ChangeBaseCoordinate(const CPoint2D<int>& rPt, bool isAbsolute);
	// indexԖڂBlock̈ʒu(/)ƏԂ𓾂
	bool GetBlock(unsigned int index, CPoint2D<int> &rPt, ETetrisBlockState &rBlockState, bool isAbsolute) const;
	// indexԖڂBlock̈ʒu(/)ƏԂݒ肷
	bool SetBlock(unsigned int index, const CPoint2D<int> &rPt, ETetrisBlockState blockState, bool isAbsolute);
	// MinoɊ܂܂Block̐Ԃ
	unsigned int GetBlockNum() const{ return m_nMinoBlockNum; }

	// WBlockStateԂ ΂ł΂łw\
	ETetrisBlockState GetBlockState(const CPoint2D<int> &rPt, bool isAbsolute) const;

	// MinoABaseWSɍ]
	void LRotate();
	// MinoABaseWSɉE]
	void RRotate();

	// MinoABaseW+(1/2, 1/2)Sɍ]
	void LRotateC();
	// MinoABaseW+(1/2, 1/2)SɉE]
	void RRotateC();

	// Oڂ钷`Ԃ
	void GetCircumscribedRect(CPoint2D<int> &rPtTopLeft, CPoint2D<int> &rPtBottomRight, bool isAbsolute) const;

protected:
	CPoint2D<int> m_ptBase; // eMinoBlock̑΍ẂA̐΍Wx[XɂĂ
	SMinoOneBlock *m_pMinoBlockArray;
	unsigned int m_nMinoBlockNum;
private:
	CMinoBlocks();
	CMinoBlocks& operator =(const CMinoBlocks&);
};

#endif // MINOBLOCKS_H
