#ifndef MINOSELECTOR_H
#define MINOSELECTOR_H

#include "Mino.h"
#include "TetrisField.h"

class CMinoSelector
{
protected:
	struct SMinoSelectInfo {
		CMino* pMino;
		unsigned int count; // 񐔃JE^
		double probability; // mvẐƂg
		SMinoSelectInfo() : pMino(NULL), count(0), probability(0.0) {}
	};
public:
	CMinoSelector(unsigned int nMinoNum);
	virtual ~CMinoSelector();

	void InitCount();
	virtual CMino* SelectMino();
	void RelateTetrisField(CTetrisField *pField);

protected:
	SMinoSelectInfo *m_pMinoSelectInfo;
	unsigned int m_nMinoNum;

private:
	CMinoSelector();
	CMinoSelector(const CMinoSelector&);
	CMinoSelector& operator =(const CMinoSelector&);
};

#endif // MINOSELECTOR_H
