#include "TGMRotationMino.h"

// TGM Rotationp̊{`FbNV[PX
// ЂƂ̃NXŒ`
bool CSegaRotationMino::TGMRotationBasicCheck()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	// ]o邩TetrisFieldɖ₢킹
	if(m_pField->CheckOverlap(*m_pMinoBlocks) == CTetrisField::OK){
		m_bWallKick = false; // ␳Ȃ
		return true;
	}

	// ɁAEɈړĂ݂
	m_pMinoBlocks->GetBaseCoordinate().x += 1;

	// ]o邩TetrisFieldɖ₢킹
	if(m_pField->CheckOverlap(*m_pMinoBlocks) == CTetrisField::OK){
		m_bWallKick = true; // ␳ꂽ
		return true;
	}

	// ɁAɈړԂŎ (ړ)
	m_pMinoBlocks->GetBaseCoordinate().x -= 2;

	// ]o邩TetrisFieldɖ₢킹
	if(m_pField->CheckOverlap(*m_pMinoBlocks) == CTetrisField::OK){
		m_bWallKick = true; // ␳ꂽ
		return true;
	}

	// ̏ꏊɖ߂
	m_pMinoBlocks->GetBaseCoordinate().x += 1;

	return false; // sc
}

// IMino
/*
 0, 180x̏ꍇ(FS)

@

@Wall Kick̉\l

 90, 270x̏ꍇ(FS)
 @@
 @@
 @@
 @@

@Floor Kick̉\l
*/
CMino::MinoResult CTGMRotationIMino::LRotate()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	// ݏ󋵂ۑĂ
	ERotateState oldRotateState = m_rotateState;

	ERotateState newRotateState = GetLRotatedState(m_rotateState);

	RotateMinoBlocks(newRotateState);

	switch(newRotateState){
	case ROTATE0:
	case ROTATE180:
	default:
		// TGM Rotation̊{`FbN(̂܂܁ˈEˈ)
		if(TGMRotationBasicCheck() & CMino::SUCCESS){
			m_rotateState = newRotateState;
			UpdateGhostMinoBlocks();
			return CMino::SUCCESS;
		}
		// EړCheck
		m_pMinoBlocks->GetBaseCoordinate().x += 2;
		// ]o邩TetrisFieldɖ₢킹
		if(m_pField->CheckOverlap(*m_pMinoBlocks) == CTetrisField::OK){
			m_rotateState = newRotateState;
			m_bWallKick = true;
			UpdateGhostMinoBlocks();
			return CMino::SUCCESS;
		}

		// _c̈ʒuɖ߂
		m_pMinoBlocks->GetBaseCoordinate().x -= 2;
		RotateMinoBlocks(oldRotateState);
		m_rotateState = oldRotateState;
		return 0;

	case ROTATE90:
	case ROTATE270:
		// ]o邩TetrisFieldɖ₢킹
		if(m_pField->CheckOverlap(*m_pMinoBlocks) == CTetrisField::OK){
			m_rotateState = newRotateState;
			return CMino::SUCCESS;
		}
		// Floor Kick`FbN(x̂)
		if(m_bFloorKickDone){
			// ɈxĂ̂NG
			RotateMinoBlocks(oldRotateState);
			m_rotateState = oldRotateState;
			return 0;
		}
		// Ɉړ
		m_pMinoBlocks->GetBaseCoordinate().y -= 1;
		// ]o邩TetrisFieldɖ₢킹
		if(m_pField->CheckOverlap(*m_pMinoBlocks) == CTetrisField::OK){
			m_bFloorKickDone = true;
			m_rotateState = newRotateState;
			m_bWallKick = true;
			UpdateGhostMinoBlocks();
			return CMino::SUCCESS;
		}

		// ɈɈړ
		m_pMinoBlocks->GetBaseCoordinate().y -= 1;
		// ]o邩TetrisFieldɖ₢킹
		if(m_pField->CheckOverlap(*m_pMinoBlocks) == CTetrisField::OK){
			m_bFloorKickDone = true;
			m_rotateState = newRotateState;
			m_bWallKick = true;
			UpdateGhostMinoBlocks();
			return CMino::SUCCESS;
		}

		// _c̈ʒuɖ߂
		m_pMinoBlocks->GetBaseCoordinate().y += 2;
		RotateMinoBlocks(oldRotateState);
		m_rotateState = oldRotateState;
		return 0;
	}
}

CMino::MinoResult CTGMRotationIMino::RRotate()
{
	return LRotate(); // L/RƂ
}

// SMino
// ʂ̏OK

CMino::MinoResult CTGMRotationSMino::LRotate()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	// ݏ󋵂ۑĂ
	ERotateState oldRotateState = m_rotateState;

	ERotateState newRotateState = GetLRotatedState(m_rotateState);

	RotateMinoBlocks(newRotateState);

	// TGM Rotation̊{`FbN(̂܂܁ˈEˈ)
	if(TGMRotationBasicCheck() & CMino::SUCCESS){
		m_rotateState = newRotateState;
		UpdateGhostMinoBlocks();
		return CMino::SUCCESS;
	}

	// ]oȂc̏Ԃɖ߂
	// ̎_ŁÄʒuɂ̂ŁAt]Ηǂ
	RotateMinoBlocks(oldRotateState);
	m_rotateState = oldRotateState;
	return 0;
}

CMino::MinoResult CTGMRotationSMino::RRotate()
{
	return LRotate(); // L/RƂ
}

// ZMino
// ʂ̏OK

CMino::MinoResult CTGMRotationZMino::LRotate()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	// ݏ󋵂ۑĂ
	ERotateState oldRotateState = m_rotateState;

	ERotateState newRotateState = GetLRotatedState(m_rotateState);

	RotateMinoBlocks(newRotateState);

	// TGM Rotation̊{`FbN(̂܂܁ˈEˈ)
	if(TGMRotationBasicCheck() & CMino::SUCCESS){
		m_rotateState = newRotateState;
		UpdateGhostMinoBlocks();
		return CMino::SUCCESS;
	}

	// ]oȂc̏Ԃɖ߂
	// ̎_ŁÄʒuɂ̂ŁAt]Ηǂ
	RotateMinoBlocks(oldRotateState);
	m_rotateState = oldRotateState;
	return 0;
}

CMino::MinoResult CTGMRotationZMino::RRotate()
{
	return LRotate(); // L/RƂ
}

// JMino
/*
 0x̏ꍇ
@@
@
@@ <= ̏ꍇ`FbNI

 90x̏ꍇ

@@
@@
@

 180x̏ꍇ
@@
@ <= _
@

 270x̏ꍇ

@@
@@
@@
*/
bool CTGMRotationJMino::RotationEnableCheck(ERotateState newRotateState)
{
	CPoint2D<int> pt;

	switch(m_rotateState){
	case ROTATE90:
	case ROTATE270:
	default:
		return true; // ɓȐȂ
	case ROTATE0:
		pt = m_pMinoBlocks->GetBaseCoordinate() + CPoint2D<int>(0, -1); // `FbN
		if(m_pField->CheckOverlap(pt) != CTetrisField::OK){
			// ]s
			return false;
		}
		pt = m_pMinoBlocks->GetBaseCoordinate() + CPoint2D<int>(0, 1); // `FbN
		if(m_pField->CheckOverlap(pt) != CTetrisField::OK){
			// ȃP[XIӏ`FbN
			pt = m_pMinoBlocks->GetBaseCoordinate() + CPoint2D<int>(1, -1); // E΂ߏ`FbN
			if(m_pField->CheckOverlap(pt) != CTetrisField::OK){
				// vt]̂݋I
				if(newRotateState == ROTATE270){
					return true;
				}else{
					return false;
				}
			}else{
				return false; // ]s
			}
		}
		return true;
	case 180:
		pt = m_pMinoBlocks->GetBaseCoordinate(); // _`FbN
		if(m_pField->CheckOverlap(pt) != CTetrisField::OK){
			// ]s
			return false;
		}
		pt = m_pMinoBlocks->GetBaseCoordinate() + CPoint2D<int>(0, 1); // `FbN
		if(m_pField->CheckOverlap(pt) != CTetrisField::OK){
			// ]s
			return false;
		}
		return true;
	}
}

CMino::MinoResult CTGMRotationJMino::LRotate()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	// ݏ󋵂ۑĂ
	ERotateState oldRotateState = m_rotateState;

	ERotateState newRotateState = GetLRotatedState(m_rotateState);

	if(!RotationEnableCheck(newRotateState)){
		return 0; // ]oȂ
	}

	RotateMinoBlocks(newRotateState);

	// TGM Rotation̊{`FbN(̂܂܁ˈEˈ)
	if(TGMRotationBasicCheck() & CMino::SUCCESS){
		m_rotateState = newRotateState;
		UpdateGhostMinoBlocks();
		return CMino::SUCCESS;
	}

	// ]oȂc̏Ԃɖ߂
	// ̎_ŁÄʒuɂ̂ŁAt]Ηǂ
	RotateMinoBlocks(oldRotateState);
	m_rotateState = oldRotateState;
	return 0;
}

CMino::MinoResult CTGMRotationJMino::RRotate()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	// ݏ󋵂ۑĂ
	ERotateState oldRotateState = m_rotateState;

	ERotateState newRotateState = GetRRotatedState(m_rotateState);

	if(!RotationEnableCheck(newRotateState)){
		return 0; // ]oȂ
	}

	RotateMinoBlocks(newRotateState);

	// TGM Rotation̊{`FbN(̂܂܁ˈEˈ)
	if(TGMRotationBasicCheck() & CMino::SUCCESS){
		m_rotateState = newRotateState;
		UpdateGhostMinoBlocks();
		return CMino::SUCCESS;
	}

	// ]oȂc̏Ԃɖ߂
	// ̎_ŁÄʒuɂ̂ŁAt]Ηǂ
	RotateMinoBlocks(oldRotateState);
	m_rotateState = oldRotateState;
	return 0;
}

// LMino
/*
 0x̏ꍇ
@
@
@

 90x̏ꍇ

@@
@@
@@

 180x̏ꍇ
@@
@@
@

 270x̏ꍇ

@
@@
@@
*/
bool CTGMRotationLMino::RotationEnableCheck(ERotateState newRotateState)
{
	CPoint2D<int> pt;

	switch(m_rotateState){
	case ROTATE90:
	case ROTATE270:
	default:
		return true; // ɓȐȂ
	case ROTATE0:
		pt = m_pMinoBlocks->GetBaseCoordinate() + CPoint2D<int>(0, -1); // `FbN
		if(m_pField->CheckOverlap(pt) != CTetrisField::OK){
			// ]s
			return false;
		}
		pt = m_pMinoBlocks->GetBaseCoordinate() + CPoint2D<int>(0, 1); // `FbN
		if(m_pField->CheckOverlap(pt) != CTetrisField::OK){
			// ȃP[XIӏ`FbN
			pt = m_pMinoBlocks->GetBaseCoordinate() + CPoint2D<int>(-1, -1); // ΂ߏ`FbN
			if(m_pField->CheckOverlap(pt) != CTetrisField::OK){
				// v]̂݋I
				if(newRotateState == ROTATE90){
					return true;
				}else{
					return false;
				}
			}else{
				return false; // ]s
			}
		}
		return true;
	case 180:
		pt = m_pMinoBlocks->GetBaseCoordinate(); // _`FbN
		if(m_pField->CheckOverlap(pt) != CTetrisField::OK){
			// ]s
			return false;
		}
		pt = m_pMinoBlocks->GetBaseCoordinate() + CPoint2D<int>(0, 1); // `FbN
		if(m_pField->CheckOverlap(pt) != CTetrisField::OK){
			// ]s
			return false;
		}
		return true;
	}
}

CMino::MinoResult CTGMRotationLMino::LRotate()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	// ݏ󋵂ۑĂ
	ERotateState oldRotateState = m_rotateState;

	ERotateState newRotateState = GetLRotatedState(m_rotateState);

	if(!RotationEnableCheck(newRotateState)){
		return 0; // ]oȂ
	}

	RotateMinoBlocks(newRotateState);

	// TGM Rotation̊{`FbN(̂܂܁ˈEˈ)
	if(TGMRotationBasicCheck() & CMino::SUCCESS){
		m_rotateState = newRotateState;
		UpdateGhostMinoBlocks();
		return CMino::SUCCESS;
	}

	// ]oȂc̏Ԃɖ߂
	// ̎_ŁÄʒuɂ̂ŁAt]Ηǂ
	RotateMinoBlocks(oldRotateState);
	m_rotateState = oldRotateState;
	return 0;
}

CMino::MinoResult CTGMRotationLMino::RRotate()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	// ݏ󋵂ۑĂ
	ERotateState oldRotateState = m_rotateState;

	ERotateState newRotateState = GetRRotatedState(m_rotateState);

	if(!RotationEnableCheck(newRotateState)){
		return 0; // ]oȂ
	}

	RotateMinoBlocks(newRotateState);

	// TGM Rotation̊{`FbN(̂܂܁ˈEˈ)
	if(TGMRotationBasicCheck() & CMino::SUCCESS){
		m_rotateState = newRotateState;
		UpdateGhostMinoBlocks();
		return CMino::SUCCESS;
	}

	// ]oȂc̏Ԃɖ߂
	// ̎_ŁÄʒuɂ̂ŁAt]Ηǂ
	RotateMinoBlocks(oldRotateState);
	m_rotateState = oldRotateState;
	return 0;
}

// TMino
/*
 0x̏ꍇ
@@
@
@@

 90x̏ꍇ

@@
@
@@

 180x̏ꍇ
@@
@@
@

 270x̏ꍇ

@@
@@
@@
*/

bool CTGMRotationTMino::RotationEnableCheck(ERotateState newRotateState)
{
	CPoint2D<int> pt;

	switch(m_rotateState){
	case ROTATE90:
	case ROTATE270:
	default:
		return true; // ɓȐȂ
	case ROTATE0:
	case ROTATE180:
		pt = m_pMinoBlocks->GetBaseCoordinate() + CPoint2D<int>(0, -1); // `FbN
		if(m_pField->CheckOverlap(pt) != CTetrisField::OK){
			// ]s
			return false;
		}
		return true;
	}
}

CMino::MinoResult CTGMRotationTMino::LRotate()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	// ݏ󋵂ۑĂ
	ERotateState oldRotateState = m_rotateState;

	ERotateState newRotateState = GetLRotatedState(m_rotateState);

	if(!RotationEnableCheck(newRotateState)){
		return 0; // ]oȂ
	}

	RotateMinoBlocks(newRotateState);

	// TGM Rotation̊{`FbN(̂܂܁ˈEˈ)
	if(TGMRotationBasicCheck() & CMino::SUCCESS){
		m_rotateState = newRotateState;
		UpdateGhostMinoBlocks();
		UpdateTSpinCondition();
		return CMino::SUCCESS;
	}

	// Floor KickA180xԂ̂
	if((newRotateState == ROTATE180) && !m_bFloorKickDone){
		m_pMinoBlocks->GetBaseCoordinate().y -= 1; // Ɉړ
		if(m_pField->CheckOverlap(*m_pMinoBlocks) == CTetrisField::OK){
			m_bFloorKickDone = true;
			m_rotateState = newRotateState;
			m_bWallKick = true;
			UpdateGhostMinoBlocks();
			UpdateTSpinCondition();
			return CMino::SUCCESS;
		}
		// _Ȃ̂ŁÄʒuɖ߂
		m_pMinoBlocks->GetBaseCoordinate().y += 1;
	}

	// ]oȂc̏Ԃɖ߂
	// ̎_ŁÄʒuɂ̂ŁAt]Ηǂ
	RotateMinoBlocks(oldRotateState);
	m_rotateState = oldRotateState;
	return 0;
}

CMino::MinoResult CTGMRotationTMino::RRotate()
{
	if(!m_pField || !m_pMinoBlocks){
		return 0; // NULLł͂Ȃ
	}

	// ݏ󋵂ۑĂ
	ERotateState oldRotateState = m_rotateState;

	ERotateState newRotateState = GetRRotatedState(m_rotateState);

	if(!RotationEnableCheck(newRotateState)){
		return 0; // ]oȂ
	}

	RotateMinoBlocks(newRotateState);

	// TGM Rotation̊{`FbN(̂܂܁ˈEˈ)
	if(TGMRotationBasicCheck() & CMino::SUCCESS){
		m_rotateState = newRotateState;
		UpdateGhostMinoBlocks();
		UpdateTSpinCondition();
		return CMino::SUCCESS;
	}

	// Floor KickA180xԂ̂
	if((newRotateState == ROTATE180) && !m_bFloorKickDone){
		m_pMinoBlocks->GetBaseCoordinate().y -= 1; // Ɉړ
		if(m_pField->CheckOverlap(*m_pMinoBlocks) == CTetrisField::OK){
			m_bFloorKickDone = true;
			m_rotateState = newRotateState;
			m_bWallKick = true;
			UpdateGhostMinoBlocks();
			UpdateTSpinCondition();
			return CMino::SUCCESS;
		}
		// _Ȃ̂ŁÄʒuɖ߂
		m_pMinoBlocks->GetBaseCoordinate().y += 1;
	}

	// ]oȂc̏Ԃɖ߂
	// ̎_ŁÄʒuɂ̂ŁAt]Ηǂ
	RotateMinoBlocks(oldRotateState);
	m_rotateState = oldRotateState;
	return 0;
}
