#ifndef MASKEDBITMAP_H
#define MASKEDBITMAP_H

#include <Windows.h>

class CMaskedBitmap
{
public:
	CMaskedBitmap() : m_hBitmapSrc(NULL), m_hBitmapMask(NULL), m_nWidth(0), m_nHeight(0) {}
	~CMaskedBitmap() { Delete(); }

	BOOL Create(HBITMAP hSrc, COLORREF colTransparent, HDC hdc);
	BOOL Delete();
	BOOL Draw(HDC hdc, int x, int y);
protected:
	HBITMAP m_hBitmapSrc;
	HBITMAP m_hBitmapMask;
	LONG m_nWidth;
	LONG m_nHeight;
};

#endif // MASKEDBITMAP_H
