#include "SRSMinoSelector.h"
#include "SRSMino.h"

CSRSMinoSelector::CSRSMinoSelector() : CMinoSelector(7)
{
	m_pMinoSelectInfo[0].pMino = new CSRSIMino();
	m_pMinoSelectInfo[1].pMino = new CSRSOMino();
	m_pMinoSelectInfo[2].pMino = new CSRSSMino();
	m_pMinoSelectInfo[3].pMino = new CSRSZMino();
	m_pMinoSelectInfo[4].pMino = new CSRSJMino();
	m_pMinoSelectInfo[5].pMino = new CSRSLMino();
	m_pMinoSelectInfo[6].pMino = new CSRSTMino();
}

CSRSMinoSelector::~CSRSMinoSelector()
{
	unsigned int i = 0;
	for(i=0; i<m_nMinoNum; i++){
		delete m_pMinoSelectInfo[i].pMino;
	}
}
