#ifndef SEGAROTATIONMINO_H
#define SEGAROTATIONMINO_H

#include "BasicMino.h"

class CSegaRotationMino : public CBasicMino
{
protected:
	// ̃o֐KI[o[Ch邱
	virtual void RotateMinoBlocks(ERotateState rotateState) = 0;

	// TGM Rotationp̃`FbNV[PX(ނ𓾂ɒ`)
	bool TGMRotationBasicCheck();

public:
	CSegaRotationMino();
	virtual ~CSegaRotationMino();

	virtual MinoResult Init();
	virtual MinoResult LRotate();
	virtual MinoResult RRotate();
};

class CSegaRotationIMino : public CSegaRotationMino
{
public:
	virtual ETetrisMino GetTetrisMinoEnum() { return TETRISMINO_I; }
protected:
	static const ETetrisBlockState s_blockState = BLOCKSTATE_CYAN;

	virtual void RotateMinoBlocks(ERotateState rotateState);
};

class CSegaRotationOMino : public CSegaRotationMino
{
public:
	virtual ETetrisMino GetTetrisMinoEnum() { return TETRISMINO_O; }
protected:
	static const ETetrisBlockState s_blockState = BLOCKSTATE_YELLOW;

	virtual void RotateMinoBlocks(ERotateState rotateState);
};

class CSegaRotationSMino : public CSegaRotationMino
{
public:
	virtual ETetrisMino GetTetrisMinoEnum() { return TETRISMINO_S; }
protected:
	static const ETetrisBlockState s_blockState = BLOCKSTATE_GREEN;

	virtual void RotateMinoBlocks(ERotateState rotateState);
};

class CSegaRotationZMino : public CSegaRotationMino
{
public:
	virtual ETetrisMino GetTetrisMinoEnum() { return TETRISMINO_Z; }
protected:
	static const ETetrisBlockState s_blockState = BLOCKSTATE_RED;

	virtual void RotateMinoBlocks(ERotateState rotateState);
};

class CSegaRotationJMino : public CSegaRotationMino
{
public:
	virtual ETetrisMino GetTetrisMinoEnum() { return TETRISMINO_J; }
protected:
	static const ETetrisBlockState s_blockState = BLOCKSTATE_BLUE;

	virtual void RotateMinoBlocks(ERotateState rotateState);
};

class CSegaRotationLMino : public CSegaRotationMino
{
public:
	virtual ETetrisMino GetTetrisMinoEnum() { return TETRISMINO_L; }
protected:
	static const ETetrisBlockState s_blockState = BLOCKSTATE_ORANGE;

	virtual void RotateMinoBlocks(ERotateState rotateState);
};

class CSegaRotationTMino : public CSegaRotationMino
{
public:
	// TSpin̂
	virtual MinoResult LRotate();
	virtual MinoResult RRotate();
	virtual ETetrisMino GetTetrisMinoEnum() { return TETRISMINO_T; }
protected:
	static const ETetrisBlockState s_blockState = BLOCKSTATE_MAGENTA;

	virtual void RotateMinoBlocks(ERotateState rotateState);
	virtual void UpdateTSpinCondition();
};
#endif // SEGAROTATIONMINO_H
