#include "SegaRotationMinoSelector.h"
#include "SegaRotationMino.h"

CSegaRotationMinoSelector::CSegaRotationMinoSelector() : CMinoSelector(7)
{
	m_pMinoSelectInfo[0].pMino = new CSegaRotationIMino();
	m_pMinoSelectInfo[1].pMino = new CSegaRotationOMino();
	m_pMinoSelectInfo[2].pMino = new CSegaRotationSMino();
	m_pMinoSelectInfo[3].pMino = new CSegaRotationZMino();
	m_pMinoSelectInfo[4].pMino = new CSegaRotationJMino();
	m_pMinoSelectInfo[5].pMino = new CSegaRotationLMino();
	m_pMinoSelectInfo[6].pMino = new CSegaRotationTMino();
}

CSegaRotationMinoSelector::~CSegaRotationMinoSelector()
{
	unsigned int i = 0;
	for(i=0; i<m_nMinoNum; i++){
		delete m_pMinoSelectInfo[i].pMino;
	}
}
