#include "TGMRotationMinoSelector.h"
#include "TGMRotationMino.h"

CTGMRotationMinoSelector::CTGMRotationMinoSelector() : CMinoSelector(7)
{
	m_pMinoSelectInfo[0].pMino = new CTGMRotationIMino();
	m_pMinoSelectInfo[1].pMino = new CTGMRotationOMino();
	m_pMinoSelectInfo[2].pMino = new CTGMRotationSMino();
	m_pMinoSelectInfo[3].pMino = new CTGMRotationZMino();
	m_pMinoSelectInfo[4].pMino = new CTGMRotationJMino();
	m_pMinoSelectInfo[5].pMino = new CTGMRotationLMino();
	m_pMinoSelectInfo[6].pMino = new CTGMRotationTMino();
}

CTGMRotationMinoSelector::~CTGMRotationMinoSelector()
{
	unsigned int i = 0;
	for(i=0; i<m_nMinoNum; i++){
		delete m_pMinoSelectInfo[i].pMino;
	}
}
