#include "TetrisCommon.h"
#include "ITetrisMgr.h"

// _~[TetrisMgrNX
// ̃NX́AegXQ[͑SĂȂ
// ꂽL[ɉāA\

class CTetrisMgrDummy : public ITetrisMgr
{
public:
	CTetrisMgrDummy() : m_gameOverCounter(0) { CTetrisMgrDummy::OnInit(); }
	virtual ~CTetrisMgrDummy() {}

	virtual EResult OnInit();    // ՖʂۂɌĂ΂
	virtual EResult OnStart();   // ՖʂAQ[X^[gɌĂ΂
	virtual EResult OnLeft();    // Ew^ꂽɌĂ΂
	virtual EResult OnRight();   // w^ꂽɌĂ΂
	virtual EResult OnLRotate(); // ]w^ꂽɌĂ΂
	virtual EResult OnRRotate(); // E]w^ꂽɌĂ΂
	virtual EResult OnDown();    // (Ƃ)w^ꂽɌĂ΂
	virtual EResult OnFall();    // P}XɗƂ^C}[ExpireɌĂ΂
	virtual unsigned int GetFallTimerInterval(); // P}XɗƂ^C}[̎ԊԊuԂ
	virtual ETetrisBlockState GetBlockState(unsigned int x, unsigned int y); // W̏Ԃ𓾂
	virtual bool IsGameOver(); // GameOverɂȂ𓾂

protected:
	ETetrisBlockState m_block[TETRIS_BLOCKNUM_X][TETRIS_BLOCKNUM_Y]; // ubNf[^
	unsigned int m_gameOverCounter;
};

CTetrisMgrDummy g_TetrisMgrDummy; // TetrisMgrCX^X̓O[oňmۂĂ

// GetTetrisMgr֐̎
ITetrisMgr* GetTetrisMgr()
{
	return &g_TetrisMgrDummy;
}

void ReleaseTetrisMgr(ITetrisMgr* pMgr)
{
	// 邱Ƃ͂Ȃ
}

// z֐̎

ITetrisMgr::EResult
CTetrisMgrDummy::OnInit()
{
	int i = 0;
	int j = 0;

	for(i=0; i<TETRIS_BLOCKNUM_X; i++){
		for(j=0; j<TETRIS_BLOCKNUM_Y; j++){
			m_block[i][j] = BLOCKSTATE_NONE;
		}
	}

	return ITetrisMgr::OK;
}

ITetrisMgr::EResult
CTetrisMgrDummy::OnStart()
{
	return ITetrisMgr::OK;
}

ITetrisMgr::EResult
CTetrisMgrDummy::OnLeft()
{
	// ׂĕ₷悤ɁActɂĂ
	const unsigned char data[TETRIS_BLOCKNUM_Y][TETRIS_BLOCKNUM_X] = {
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 1, 0, 0, 0, 0, 0},
		{0, 0, 0, 1, 1, 0, 0, 0, 0, 0},
		{0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
		{0, 1, 1, 1, 1, 1, 1, 1, 1, 1},
		{1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
		{0, 1, 1, 1, 1, 1, 1, 1, 1, 1},
		{0, 0, 1, 1, 1, 0, 0, 0, 0, 0},
		{0, 0, 0, 1, 1, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 1, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
	};

	int i = 0;
	int j = 0;

	for(i=0; i<TETRIS_BLOCKNUM_X; i++){
		for(j=0; j<TETRIS_BLOCKNUM_Y; j++){
			if(data[j][i]){
				m_block[i][j] = BLOCKSTATE_CYAN;
			}else{
				m_block[i][j] = BLOCKSTATE_NONE;
			}
		}
	}

	m_gameOverCounter++;
	return ITetrisMgr::OK;
}

ITetrisMgr::EResult
CTetrisMgrDummy::OnRight()
{
	// ׂĕ₷悤ɁActɂĂ
	const unsigned char data[TETRIS_BLOCKNUM_Y][TETRIS_BLOCKNUM_X] = {
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 1, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 1, 1, 0, 0, 0},
		{0, 0, 0, 0, 0, 1, 1, 1, 0, 0},
		{1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
		{1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
		{1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
		{0, 0, 0, 0, 0, 1, 1, 1, 0, 0},
		{0, 0, 0, 0, 0, 1, 1, 0, 0, 0},
		{0, 0, 0, 0, 0, 1, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
	};

	int i = 0;
	int j = 0;

	for(i=0; i<TETRIS_BLOCKNUM_X; i++){
		for(j=0; j<TETRIS_BLOCKNUM_Y; j++){
			if(data[j][i]){
				m_block[i][j] = BLOCKSTATE_YELLOW;
			}else{
				m_block[i][j] = BLOCKSTATE_NONE;
			}
		}
	}

	m_gameOverCounter++;
	return ITetrisMgr::OK;
}

ITetrisMgr::EResult
CTetrisMgrDummy::OnLRotate()
{
	// ׂĕ₷悤ɁActɂĂ
	const unsigned char data[TETRIS_BLOCKNUM_Y][TETRIS_BLOCKNUM_X] = {
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 1, 0, 0, 0, 0, 0, 0},
		{0, 0, 1, 1, 0, 0, 0, 0, 0, 0},
		{0, 1, 1, 1, 1, 1, 1, 0, 0, 0},
		{1, 1, 1, 1, 1, 1, 1, 1, 0, 0},
		{0, 1, 1, 1, 1, 1, 1, 1, 1, 0},
		{0, 0, 1, 1, 0, 0, 1, 1, 1, 1},
		{0, 0, 0, 1, 0, 0, 0, 1, 1, 1},
		{0, 0, 0, 0, 0, 0, 0, 1, 1, 1},
		{0, 0, 0, 0, 0, 0, 0, 1, 1, 1},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
	};

	int i = 0;
	int j = 0;

	for(i=0; i<TETRIS_BLOCKNUM_X; i++){
		for(j=0; j<TETRIS_BLOCKNUM_Y; j++){
			if(data[j][i]){
				m_block[i][j] = BLOCKSTATE_GREEN;
			}else{
				m_block[i][j] = BLOCKSTATE_NONE;
			}
		}
	}

	m_gameOverCounter++;
	return ITetrisMgr::OK;
}

ITetrisMgr::EResult
CTetrisMgrDummy::OnRRotate()
{
	// ׂĕ₷悤ɁActɂĂ
	const unsigned char data[TETRIS_BLOCKNUM_Y][TETRIS_BLOCKNUM_X] = {
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 1, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 1, 1, 0, 0},
		{0, 0, 0, 1, 1, 1, 1, 1, 1, 0},
		{0, 0, 1, 1, 1, 1, 1, 1, 1, 1},
		{0, 1, 1, 1, 1, 1, 1, 1, 1, 0},
		{1, 1, 1, 1, 0, 0, 1, 1, 0, 0},
		{1, 1, 1, 0, 0, 0, 1, 0, 0, 0},
		{1, 1, 1, 0, 0, 0, 0, 0, 0, 0},
		{1, 1, 1, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
	};

	int i = 0;
	int j = 0;

	for(i=0; i<TETRIS_BLOCKNUM_X; i++){
		for(j=0; j<TETRIS_BLOCKNUM_Y; j++){
			if(data[j][i]){
				m_block[i][j] = BLOCKSTATE_RED;
			}else{
				m_block[i][j] = BLOCKSTATE_NONE;
			}
		}
	}

	m_gameOverCounter++;
	return ITetrisMgr::OK;
}

ITetrisMgr::EResult
CTetrisMgrDummy::OnDown()
{
	// ׂĕ₷悤ɁActɂĂ
	const unsigned char data[TETRIS_BLOCKNUM_Y][TETRIS_BLOCKNUM_X] = {
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 1, 1, 1, 0, 0, 0, 0},
		{0, 0, 0, 1, 1, 1, 0, 0, 0, 0},
		{0, 0, 0, 1, 1, 1, 0, 0, 0, 0},
		{0, 0, 0, 1, 1, 1, 0, 0, 0, 0},
		{0, 0, 0, 1, 1, 1, 0, 0, 0, 0},
		{1, 1, 1, 1, 1, 1, 1, 1, 1, 0},
		{0, 1, 1, 1, 1, 1, 1, 1, 0, 0},
		{0, 0, 1, 1, 1, 1, 1, 0, 0, 0},
		{0, 0, 0, 1, 1, 1, 0, 0, 0, 0},
		{0, 0, 0, 0, 1, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
	};

	int i = 0;
	int j = 0;

	for(i=0; i<TETRIS_BLOCKNUM_X; i++){
		for(j=0; j<TETRIS_BLOCKNUM_Y; j++){
			if(data[j][i]){
				m_block[i][j] = BLOCKSTATE_BLUE;
			}else{
				m_block[i][j] = BLOCKSTATE_NONE;
			}
		}
	}

	m_gameOverCounter++;
	return ITetrisMgr::OK;
}

ITetrisMgr::EResult
CTetrisMgrDummy::OnFall(){
	return CTetrisMgrDummy::OnInit();
}

unsigned int CTetrisMgrDummy::GetFallTimerInterval()
{
	return 1000; // 1b
}

ETetrisBlockState 
CTetrisMgrDummy::GetBlockState(unsigned int x, unsigned int y)
{
	if((x < TETRIS_BLOCKNUM_X) && (y < TETRIS_BLOCKNUM_Y)){
		return m_block[x][y];
	}else{
		return BLOCKSTATE_NONE;
	}
}

bool CTetrisMgrDummy::IsGameOver()
{
	if(m_gameOverCounter > 100){
		m_gameOverCounter = 0;
		return true;
	}else{
		return false;
	}
}
