#include "TetrisOnFloorChecker.h"

CTetrisOnFloorChecker::CTetrisOnFloorChecker(unsigned int nYLen, unsigned int nYMarginLen)
{
	m_pData = new int[nYLen + nYMarginLen];
	m_nYLen = nYLen + nYMarginLen;
	m_nYBase = nYMarginLen;

	CTetrisOnFloorChecker::ClearCount();
}

CTetrisOnFloorChecker::~CTetrisOnFloorChecker()
{
	delete[] m_pData;
}

void CTetrisOnFloorChecker::ClearCount()
{
	unsigned int i = 0;
	for(i=0; i<m_nYLen; i++){
		m_pData[i] = 0;
	}

	m_nYPrevIndex = -1;
}

void CTetrisOnFloorChecker::NotOnFloor()
{
	m_nYPrevIndex = -1;
}

bool CTetrisOnFloorChecker::AddCountAndCheckTimerReset(int nY)
{
	// Indexɂ
	nY += m_nYBase;
	// ͈̓`FbN
	if((nY < 0) || (nY >= (int)m_nYLen)){
		return false;
	}
	// O`FbNƓȂAăZbgȂ
	if(nY == m_nYPrevIndex){
		return false;
	}
	m_pData[nY] ++;
	m_nYPrevIndex = nY;

	// ́A܂ŋ
	if(m_pData[nY] <= 2){
		return true;
	}else{
		return false;
	}
}
