#ifndef TETRISONFLOORCHECKER_H
#define TETRISONFLOORCHECKER_H

class CTetrisOnFloorChecker
{
public:
	CTetrisOnFloorChecker(unsigned int nYLen, unsigned int nYMarginLen);
	virtual ~CTetrisOnFloorChecker();

	void ClearCount();
	void NotOnFloor(); // 󒆂̏ꍇ
	bool AddCountAndCheckTimerReset(int nY); // TimerăZbg`FbN

protected:
	int *m_pData;
	unsigned int m_nYLen;  // YTCY
	int m_nYBase; // BaseW(y)
	int m_nYPrevIndex; // OYIndex
private:
	CTetrisOnFloorChecker();
	CTetrisOnFloorChecker(const CTetrisOnFloorChecker&);
	CTetrisOnFloorChecker& operator =(const CTetrisOnFloorChecker&);
};

#endif // TETRISONFLOORCHECKER_H
